apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    name: {{ haproxy_name }}
  name: {{ haproxy_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ haproxy_replicas }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ haproxy_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ haproxy_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ haproxy_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ haproxy_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ haproxy_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='haproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='haproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 20
          periodSeconds: 20
          tcpSocket:
            port: {{ haproxy_port }}
          timeoutSeconds: 3
        name: haproxy
        ports:
        - containerPort: {{ haproxy_port }}
        readinessProbe:
          failureThreshold: 5
          initialDelaySeconds: 20
          periodSeconds: 10
          tcpSocket:
            port: {{ haproxy_port }}
          timeoutSeconds: 2
        resources:
          limits:
            cpu: "{{ haproxy_cpu_limit }}"
            memory: "{{ haproxy_memory_limit }}"
          requests:
            cpu: "{{ haproxy_cpu_request }}"
            memory: "{{ haproxy_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 20
          tcpSocket:
            port: {{ haproxy_port }}
          timeoutSeconds: 3
{% endif %}
        volumeMounts:
        - mountPath: /usr/local/etc/haproxy
          name: config
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if k8s_flavor == 'kubernetes' or ('net.core.somaxconn' in allowed_unsafe_sysctls) %}
      securityContext:
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% if 'net.core.somaxconn' in allowed_unsafe_sysctls %}
        sysctls:
        - name: net.core.somaxconn
          value: "10000"
{% endif %}
{% endif %}
      serviceAccountName: {{ haproxy_sa | default('default') }}
      volumes:
      - configMap:
          defaultMode: 420
          name: {{ haproxy_name }}
        name: config
{% if (do_triggers | default(False)) != False %}
  triggers:
{% if (opsimages | json_query("[?name=='haproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - haproxy
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='haproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
